#ifndef __AUDIOFX__
#define __AUDIOFX__

//#include <qstring.h>

#include "csample.h"

#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#ifndef SIGN
#define SIGN(a)		((a) == 0?0:((a) < 0?-1:1))
#endif

class CAFX
{
protected:
	double		progress;
	QString		module;

public:
	CAFX()
	{
	};

	double	CAFX::afxfn(double x,QArray<double> points,int sym);
	double	CAFX::afxcompress(double x,double level);
	double	CAFX::afxexpand(double x,double level);

	double	getProgress() {return progress;};
	QString	getModule() {return module;};

	void	deeppass(CSample *s,double,double,uint pos,uint len);
	void	highpass(CSample *s,double,double,uint pos,uint len);
	double	calcDCOffset(CSample *s,int pos,uint len);
	void	optimizeDCOffset(CSample *smp,int pos,uint len);
	void	offsetDC(CSample *smp,double offset,int pos,uint len);
	double	calcVolume(CSample *smp,int pos,uint len);
	void	volume(CSample *smp,int pos,uint len);
	void	volume(CSample *smp,double vol,int pos,uint len);
	void	volume(CSample *smp,QArray<double> points,int pos,uint len);
	void	echo(CSample *smp,double delay,double volume,double release,uint pos,uint len);
	void	reverb(CSample *smp,double delay,double volume,double mix,uint pos,uint len);
	void	fuzz(CSample *smp,double volume,double cut,int side,uint pos,uint len);
	void	hull(CSample *smp,uint pos,uint len);
	void	noiseGate(CSample *smp,double treshhold,uint pos,uint len);
	void	distortion(CSample *smp,QArray<double> points,int symmetric,uint pos,uint len);
	void	compress(CSample *smp,double level,uint pos,uint len);
	void	expand(CSample *smp,double level,uint pos,uint len);
};


#endif

