#include "carray.h"

template<class type>
CArray<type>::CArray(int size) : QArray<type>(size)
{
}

template<class type>
CArray<type>::CArray( const CArray<type> &a) : QArray<type>(a)
{
}

template<class type>
bool	CArray<type>::insert(CArray<type> *a,uint index)
{
	if(resize(size() + a->size() * sizeof(type)))
	{
		type	*d;

		d = data();
		move(d + index + a->size(),d + index,a->size());
		move(d + index,a->data(),a->size());

		return TRUE;
	}
	return FALSE;
}

template<class type>
bool	CArray<type>::insert(type *a,uint n,uint index)
{
	if(resize(size() + n * sizeof(type))
	{
		type	*d;

		d = data();
		move(d + index + n,d + index,n);
		move(d + index,a,n);

		return TRUE;
	}
	return FALSE;
}

template<class type>
bool	CArray<type>::replace(CArray<type> *a,uint index)
{
	type	*d;

	d = data();
	move(d + index,a->data(),a->size());

	return TRUE;
}

template<class type>
bool	CArray<type>::replace(type *a,uint n,uint index)
{
	type	*d;

	d = data();
	move(d + index,a,n);

	return TRUE;
}

template<class type>
bool	CArray<type>::cut(uint index,uint n)
{
	type	*d;

	d = data();
	move(d + index,d + index + n,size() - index - n);

	return resize(size() - n);
}

template<class type>
bool	CArray<type>::del(uint index)
{
	return cut(index,1);
}

template<class type>
bool	CArray<type>::get(CArray<type>*a,uint index,uint n)
{
	if(a->resize(n))
	{
		type	*d;

		d = a->data();
		move(d,data() + index,n);

		return TRUE;
	}
	return FALSE;
}

template<class type>
bool	CArray<type>::get(type *d,uint index,uint n)
{
	move(d,data() + index,n);

	return TRUE;
}

template<class type>
bool	CArray<type>::move(type *d,type *s,uint n)
{
	move(d,s,n * sizeof(type));

	return TRUE;
}

#ifdef TEST_CARRAY

#include <stdio.h>

int	main(void)
{
	int		t;
	CArray<double>	da(12);

	for(t = 0;t < 12;t++) da[t] = (double)t / 12;
	for(t = 0;t < 12;t++) printf("%i / 12 = %f\n",t,da[t]);

	return 0;
}

#endif


