//
// ksoundsys - KDE
//

#include <qkeycode.h>
#include <kmsgbox.h>
#include <kintegerline.h>
#include <qframe.h>
#include <qmsgbox.h>

#include <klocale.h>

#define stloc(a)	((char*)klocale->translate((a)))

#include "ksoundsys.h"
#include "ksoundsys.moc"

KApplication	*mykapp;

char	*sprinttf(char *d,char *f,int v)
{
	int	h,m,s,u;
	int	t,i,l;
	char	fi[8];

	u = v % 1000;
	s = (v / 1000) % 60;
	m = (v / 60000) % 60;
	h = (v / 3600000);

	for(t = 0,i = 0;t < (int)strlen(f);t++)
	{
		if(f[t] != '%')
		{
			d[i++] = f[t];
			d[i] = 0;
		}
		else
		{
			if((l = atoi(f + t + 1)) != 0)
			{
				sprintf(fi,"%%0%ii",l);
				t++;
			}
			else
				sprintf(fi,"%%i");
			switch(f[++t])
			{
				case 'i':
					sprintf(d + i,fi,v);
				break;
				case 'u':
					sprintf(d + i,fi,u);
				break;
				case 's':
					sprintf(d + i,fi,s);
				break;
				case 'm':
					sprintf(d + i,fi,m);
				break;
				case 'h':
					sprintf(d + i,fi,h);
				break;
				default:
					d[i] = f[t];
			}
			i = strlen(d);
		}
	}
	return d;
}

int	main(int argc,char **argv)
{
	ksoundsys	*win;

	mykapp = new KApplication(argc,argv,"ksoundsys");
	if ( mykapp->isRestored() )
	{
		int n = 1;

		while (KTopLevelWidget::canBeRestored(n))
		{	
			ksoundsys *tl = new ksoundsys(mykapp);
			tl->restore(n);
			n++;
		}

	} 
	else
	{

		win = new ksoundsys(mykapp);

		mykapp->setMainWidget(win);

		win->resize(500,345);
		win->setMaximumSize(1000,700);
		win->setMinimumSize(500,200);

		win->show();
	}

	return mykapp->exec();
}

ksoundsys::ksoundsys(KApplication *ka) : KTopLevelWidget()
{
	projectname = NULL;
	changed = FALSE;

	undosample = new CSample(1,SMPFLAGS_TYPE_DB,0);
	cnpsample = new CSample();

	app = ka;
	config = ka->getConfig();

	createWidgets();

	{
		QString		group = "Option",str;

		config->setGroup(group);

		str = config->readEntry("DSP","/dev/dsp");

		kswp->getSample()->setAudioDevice(str);
	}
}

ksoundsys::~ksoundsys()
{
	if(changed) printf("Actuel Data not saved!\n");

	if(projectname) free(projectname);

	delete undosample;
	delete cnpsample;

	delete kswp;
	delete stbar;
	delete tb_file;
	delete tb_edit;
	delete tb_filter;
	delete tb_audio;
	delete Mfile;
	delete Medit;
	delete Maudio;
	delete Mfilter;
	delete Moptions;
	delete Mhelp;
	delete mainmenu;
}

void	ksoundsys::createWidgets()
{
	QString		qstr;
	char		str[24];
	QColor		c[11],*qc;
	//int		t;

	//for(t = 0;t < 11;t++) c[t] = new QColor();
	config->setGroup("SoundWidgetColors");
	qc = new QColor();
	qc->setRgb(255,255,255);
	c[0] = config->readColorEntry("Background",qc);
	qc->setRgb(0,0,0);
	c[1] = config->readColorEntry("Foreground",qc);
	qc->setRgb(100,100,150);
	c[2] = config->readColorEntry("NoColor",qc);
	qc->setRgb(0,200,0);
	c[3] = config->readColorEntry("Middleline",qc);
	qc->setRgb(50,50,50);
	c[4] = config->readColorEntry("Devideline",qc);
	qc->setRgb(0,0,0);
	c[5] = config->readColorEntry("SelectedBackground",qc);
	qc->setRgb(255,255,255);
	c[6] = config->readColorEntry("SelectedForeground",qc);
	qc->setRgb(200,0,0);
	c[7] = config->readColorEntry("SelectedMiddleline",qc);
	qc->setRgb(0,0,200);
	c[8] = config->readColorEntry("Pointer",qc);
	qc->setRgb(0,0,200);
	c[9] = config->readColorEntry("SelectedPointer",qc);
	qc->setRgb(0,0,150);
	c[10] = config->readColorEntry("Zoom",qc);

	delete qc;

	setCaption( "KSoundSys V" VERSION);

	createMenu();
	createToolBars();

	kswp = new KSoundWidgetPro(this,app);
	kswp->setColors(c);
	
	stbar = new KStatusBar(this);
	qstr = stloc("Time: ");
	qstr += sprinttf(str,"%h:%2m:%2s.%3u",0);
	stbar->insertItem(qstr,3);
	qstr = stloc("Samples: ");
	sprintf(str,"%18i",0);
	qstr += str;
	stbar->insertItem(qstr,2);
	stbar->insertItem("Stereo",4);
	stbar->insertItem(stloc("DBL"),5);
	stbar->insertItem(stloc("No File!"),1);
	stbar->setInsertOrder(KStatusBar::RightToLeft);
	stbar->enable(KStatusBar::Show);
	stbar->show();

	setView(kswp,TRUE);
	setMenu(mainmenu);
	setStatusBar(stbar);

	connect(kswp,SIGNAL(gotURL(char*,int)),SLOT(insertDND(char*,int)));
}

void	ksoundsys::createMenu()
{
	int		i,t;

	config->setGroup("Recent Files");
	i = config->readNumEntry("NFiles",8);

	Mopenrecent = new MPopupMenu;
	CHECK_PTR(Mopenrecent);

	for(t = 0;t < i;t++)
	{
		QString		qstr = "";

		qstr.sprintf("File%i",t);
		qstr = config->readEntry(qstr,"!");
		if(qstr != "!") Mopenrecent->insertItem(qstr,1000 + t);
	}

	connect(Mopenrecent,SIGNAL(activated(int)),this,SLOT(openRecentClicked(int)));
	
	Mfile = new MPopupMenu;
	CHECK_PTR(Mfile);
	mid[0] = Mfile->insertItem(klocale->translate("New"),this,SLOT(newClicked()),CTRL+Key_N);
	Mfile->insertSeparator();
	mid[1] = Mfile->insertItem(klocale->translate("Open"),this,SLOT(openClicked()),CTRL+Key_O);
	mid[2] = Mfile->insertItem(klocale->translate("Open Recent"),Mopenrecent);
	Mfile->insertSeparator();
	mid[3] = Mfile->insertItem(klocale->translate("Save"),this,SLOT(saveClicked()),CTRL+Key_S);
	mid[4] = Mfile->insertItem(klocale->translate("Save As"),this,SLOT(saveAsClicked()),0);
	Mfile->insertSeparator();
	mid[6] = Mfile->insertItem(klocale->translate("Exit"),this,SLOT(quitClicked()),CTRL+Key_Q);

	Medit = new MPopupMenu;
	CHECK_PTR(Medit);
	mid[10] = Medit->insertItem(klocale->translate("Copy"),this,SLOT(copyClicked()),CTRL+Key_C);
	mid[11] = Medit->insertItem(klocale->translate("Cut"),this,SLOT(cutClicked()),CTRL+Key_X);
	mid[12] = Medit->insertItem(klocale->translate("Paste"),this,SLOT(pasteClicked()),CTRL+Key_V);
	Medit->insertSeparator();
	mid[13] = Medit->insertItem(klocale->translate("insert Silence ..."),this,SLOT(silenceClicked()),0);
	Medit->insertSeparator();
	mid[14] = Medit->insertItem(klocale->translate("Format ..."),this,SLOT(formatClicked()),0);

	Maudio = new MPopupMenu;
	CHECK_PTR(Maudio);
	mid[20] = Maudio->insertItem(klocale->translate("Play"),this,SLOT(playClicked()),0);
	mid[21] = Maudio->insertItem(klocale->translate("Stop"),this,SLOT(stopClicked()),0);
	Maudio->setItemEnabled(mid[21],FALSE);
	mid[22] = Maudio->insertItem(klocale->translate("Pause"),this,SLOT(pauseClicked()),0);
	Maudio->setItemEnabled(mid[22],FALSE);
	Maudio->insertSeparator();
	mid[23] = Maudio->insertItem(klocale->translate("Record"),this,SLOT(recordClicked()),0);

	Mfilter = new MPopupMenu;
	CHECK_PTR(Mfilter);
	mid[40] = Mfilter->insertItem(klocale->translate("DeepPass ..."),this,SLOT(deeppassClicked()),0);
	mid[41] = Mfilter->insertItem(klocale->translate("HighPass ..."),this,SLOT(highpassClicked()),0);
	mid[42] = Mfilter->insertItem(klocale->translate("Echo ..."),this,SLOT(echoClicked()),0);
	mid[43] = Mfilter->insertItem(klocale->translate("Volume ..."),this,SLOT(volumeClicked()),0);
	mid[52] = Mfilter->insertItem(klocale->translate("Envelope ..."),this,SLOT(envelopeClicked()),0);
	mid[44] = Mfilter->insertItem(klocale->translate("Optimize Volume"),this,SLOT(optimizeVolumeClicked()),0);
	mid[45] = Mfilter->insertItem(klocale->translate("DC-Offset ..."),this,SLOT(dcoffsetClicked()),0);
	mid[46] = Mfilter->insertItem(klocale->translate("Optimize DC-Offset"),this,SLOT(optimizeDCOffsetClicked()),0);
	mid[50] = Mfilter->insertItem(klocale->translate("Fuzz ..."),this,SLOT(fuzzClicked()),0);
	mid[47] = Mfilter->insertItem(klocale->translate("Noisegate ..."),this,SLOT(noisegateClicked()),0);
	mid[48] = Mfilter->insertItem(klocale->translate("PitchShift ..."),this,SLOT(pitchShiftClicked()),0);
	mid[51] = Mfilter->insertItem(klocale->translate("Distortion ..."),this,SLOT(distortionClicked()),0);
	mid[49] = Mfilter->insertItem(klocale->translate("Hullcurve"),this,SLOT(hullcurveClicked()),0);
	mid[53] = Mfilter->insertItem(klocale->translate("Compress ..."),this,SLOT(compressClicked()),0);
	mid[54] = Mfilter->insertItem(klocale->translate("Expand ..."),this,SLOT(expandClicked()),0);

	Moptions = new MPopupMenu;
	CHECK_PTR(Moptions);
	mid[30] = Moptions->insertItem(klocale->translate("Options"),this,SLOT(optionsClicked()),0);
	mid[31] = Moptions->insertItem(klocale->translate("Colors"),this,SLOT(colorsClicked()),0);

	Mhelp = new MPopupMenu;
	CHECK_PTR(Mhelp);

	QString		str;

	str = "KSoundSys V" VERSION " (c) 1998, 1999 Tobias Wollgam \n\n";
	str += klocale->translate("Soundfile editor for the");
	str += " KDE Desktop Environment\n\n";
	str += klocale->translate("Please report bugs to");
	str += ": wollgam@cww.de\n";
	//KMsgBox	mb(0,stloc("About"),str,1,stloc("Quit"));
		       
	Mhelp = mykapp->getHelpMenu(true, str.data());

/*
	mid[7] = Mhelp->insertItem(klocale->translate("Help"),this,SLOT(helpClicked()),0);
	Mhelp->insertSeparator();
	mid[9] = Mhelp->insertItem(klocale->translate("About QT ..."),this,SLOT(aboutQtClicked()),0);
	mid[8] = Mhelp->insertItem(klocale->translate("About ..."),this,SLOT(aboutClicked()),0);
*/

	mainmenu = new KMenuBar(this,"mainmenu");
	CHECK_PTR(mainmenu);
	mainmenu->insertItem(klocale->translate("&File"),Mfile);
	mainmenu->insertItem(klocale->translate("&Edit"),Medit);
	mainmenu->insertItem(klocale->translate("&Audio"),Maudio);
	mainmenu->insertItem(klocale->translate("F&ilter"),Mfilter);
	mainmenu->insertItem(klocale->translate("&Options"),Moptions);
	mainmenu->insertSeparator();
	mainmenu->insertItem(klocale->translate("&Help"),Mhelp);
}

void	ksoundsys::createToolBars()
{
	int		id = 0;
	QPixmap		pm,&qp = pm;
	QString		pixdir;

	//pixdir = getenv("KDEDIR") + "/lib/pics/toolbar/";
	//pixdir = app->kde_toolbardir() + "/";
	pixdir = app->kde_datadir() + "/ksoundsys/toolbar/";

	printf("toolbardir: %s\n",pixdir.data());

/*
	printf("appsdir: %s\n",app->kde_appsdir().data());
	printf("icondir: %s\n",app->kde_icondir().data());
	printf("datadir: %s\n",app->kde_datadir().data());
	printf("localedir: %s\n",app->kde_localedir().data());
	printf("configdir: %s\n",app->kde_configdir().data());
	printf("bindir: %s\n",app->kde_bindir().data());
	printf("localkdedir: %s\n",app->localkdedir().data());
	printf("localconfigdir: %s\n",app->localconfigdir().data());
*/

	tb_file = new KToolBar(this);

/*
	qp.load(pixdir + "exit.xpm");
	tb_file->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(quitClicked()),TRUE,
		klocale->translate("Close ksoundsys"),-1);
	tb_file->insertSeparator();
*/

	qp.load(pixdir + "filenew.xpm");
	tb_file->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(newClicked()),TRUE,
		klocale->translate("New File"),-1);

	qp.load(pixdir + "fileopen.xpm");
	tb_file->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(openClicked()),TRUE,
		klocale->translate("Open File"),-1);

	qp.load(pixdir + "filesave.xpm");
	tb_file->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(saveClicked()),TRUE,
		klocale->translate("Save File"),-1);

	qp.load(pixdir + "filesaveas.xpm");
	tb_file->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(saveAsClicked()),TRUE,
		klocale->translate("Save File As"),-1);

	tb_edit = new KToolBar(this);

	qp.load(pixdir + "editcopy.xpm");
	tb_edit->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(copyClicked()),TRUE,
		klocale->translate("Copy Selection"),-1);

	qp.load(pixdir + "editcut.xpm");
	tb_edit->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(cutClicked()),TRUE,
		klocale->translate("Cut Selection"),-1);

	qp.load(pixdir + "editpaste.xpm");
	tb_edit->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(pasteClicked()),TRUE,
		klocale->translate("Paste at Pointer"),-1);

	tb_edit->insertSeparator();

/*
	qp.load(pixdir + "viewedit.xpm");
	tb_edit->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(editModeClicked()),TRUE,
		klocale->translate("Editmode"),-1);

	qp.load(pixdir + "viewmag.xpm");
	tb_edit->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(zoomModeClicked()),TRUE,
		klocale->translate("Zoommode"),-1);

*/
	tb_filter = new KToolBar(this);
	tb_audio = new KToolBar(this);

	qp.load(pixdir + "audioplay.xpm");
	tb_audio->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(playClicked()),TRUE,
		klocale->translate("Play"),-1);

	qp.load(pixdir + "audiostop.xpm");
	tb_audio->insertButton(qp,id++,
		SIGNAL(clicked()),this,
		SLOT(stopClicked()),TRUE,
		klocale->translate("Stop"),-1);

	addToolBar(tb_file);
	tb_file->setMaxWidth(10 + 4 * 30);
	addToolBar(tb_edit);
	tb_edit->setMaxWidth(10 + 5 * 30 - 2 *30);
	addToolBar(tb_filter);
	tb_filter->setMaxWidth(10 + 0 * 30);
	addToolBar(tb_audio);
	tb_audio->setMaxWidth(10 + 2 * 30);
}

void	ksoundsys::disableMenu()
{
/*
	int		t;

	for(t = 0;t < 7;t++) Mfile->setItemEnabled(mid[t],FALSE);
	for(t = 7;t < 9;t++) Mhelp->setItemEnabled(mid[t],FALSE);
	for(t = 10;t < 15;t++) Medit->setItemEnabled(mid[t],FALSE);
	for(t = 20;t < 14;t++) Maudio->setItemEnabled(mid[t],FALSE);
	for(t = 30;t < 32;t++) Moptions->setItemEnabled(mid[t],FALSE);
	for(t = 40;t < 53;t++) Mfilter->setItemEnabled(mid[t],FALSE);
*/
}

void	ksoundsys::enableMenu()
{
/*
	int		t;

	for(t = 0;t < 7;t++) Mfile->setItemEnabled(mid[t],TRUE);
	for(t = 7;t < 9;t++) Mhelp->setItemEnabled(mid[t],TRUE);
	for(t = 10;t < 15;t++) Medit->setItemEnabled(mid[t],TRUE);
	for(t = 20;t < 14;t++) Maudio->setItemEnabled(mid[t],TRUE);
	for(t = 30;t < 32;t++) Moptions->setItemEnabled(mid[t],TRUE);
	for(t = 40;t < 53;t++) Mfilter->setItemEnabled(mid[t],TRUE);
*/
}

void	ksoundsys::setRecent(char *file)
{
	int		i,t;
	QString		qstr = "";
	QStrIList	strlist;

	config->setGroup("Recent Files");
	i = config->readNumEntry("NFiles",8);

	strlist.insert(0,file);

	for(t = 0;t < i;t++)
	{
		qstr.sprintf("File%i",t);
		qstr = config->readEntry(qstr,"!");
		if(qstr != "!" && strlist.find(qstr) == -1)
		{
			strlist.insert(strlist.count(),qstr);
		}
	}

	strlist.first();
	Mopenrecent->clear();
	for(t = 0;t < i;t++)
	{
		qstr.sprintf("File%i",t);
		if(strlist.current() == NULL) config->writeEntry(qstr,"!");
		else
		{
			config->writeEntry(qstr,strlist.current());
			if(strlist.current() != "!") Mopenrecent->insertItem(strlist.current(),1000 + t);
		}
		strlist.next();
	}
	config->sync();
}

void	ksoundsys::timerEvent(QTimerEvent *te)
{
	if(te == NULL) return;
	
	if(kswp->getSample()->playing()) kswp->getSample()->playbackevent();
	else
	{
		killTimers();
		kswp->getSample()->stop();

		Maudio->setItemEnabled(mid[20],TRUE);
		Maudio->setItemEnabled(mid[21],FALSE);
		Maudio->setItemEnabled(mid[22],FALSE);
		Maudio->setItemEnabled(mid[23],TRUE);
	}
}



// **************************************************************************
//
//
//
//
//
//
//
//	Slots
//
//
//
//
//
//
//
// **************************************************************************



void	ksoundsys::newClicked()
{
	if(changed)
	{
		QString		str;
		int		result;

		str = "ksoundsys V" VERSION " \n\n";
		str += klocale->translate("The data has changed and is currently not saved!");
		KMsgBox	mb;
		result = mb.yesNoCancel(0,stloc("New data"),str,8,stloc("Abort"),stloc("Save now"),stloc("New"));
		if(result == 1) return;
		if(result == 2) saveClicked();
	}

	{
	int		sr = 44100;
	int		c = 2;
	int		t = 4;
	newdialog	fd(this,"New",config,sr,t,c);
	QString		qstr;
	char		str[24];

	fd.show();

	if(fd.result())
	{
		sr = fd.getSampleRate();
		c = fd.getNChannel();
		t = fd.getType();

		kswp->getSample()->clear();

		kswp->getSample()->addChannel(c);
		kswp->getSample()->convertToTypeDB();
		if(t == 0) kswp->getSample()->convertTypeDBToType8();
		if(t == 1) kswp->getSample()->convertTypeDBToType16();
		if(t == 2) kswp->getSample()->convertTypeDBToType32();
		if(t == 3) kswp->getSample()->convertTypeDBToTypeFL();

		kswp->getSample()->setRate(sr);

		{
			QString		group = "Option",str;

			config->setGroup(group);

			str = config->readEntry("DSP","/dev/dsp");

			kswp->getSample()->setAudioDevice(str);
		}

		stbar->changeItem(stloc("New"),1);

		changed = FALSE;

		kswp->setSample();

		qstr = stloc("Time: ");
		qstr += sprinttf(str,"%h:%2m:%2s.%3u",
			(int)((double)kswp->getSample()->getLength() / 
			       (double)kswp->getSample()->getRate() * 1000));
		stbar->changeItem(qstr,3);
		qstr = stloc("Samples: ");
		sprintf(str,"%12i",kswp->getSample()->getLength());
		qstr += str;
		stbar->changeItem(qstr,2);
		switch(kswp->getSample()->getNChannel())
		{
			case 1:
				stbar->changeItem(" Mono",4);
			break;
			case 2:
				stbar->changeItem("Stereo",4);
			break;
			case 4:
				stbar->changeItem("Quadro",4);
			break;
			default:
				sprintf(str,"%i",kswp->getSample()->getNChannel());
				stbar->changeItem(str,4);
		}
		if(kswp->getSample()->isType8()) stbar->changeItem(stloc("Int8"),5);
		if(kswp->getSample()->isType16()) stbar->changeItem(stloc("Int16"),5);
		if(kswp->getSample()->isType32()) stbar->changeItem(stloc("Int32"),5);
		if(kswp->getSample()->isTypeFL()) stbar->changeItem(stloc("FLT"),5);
		if(kswp->getSample()->isTypeDB()) stbar->changeItem(stloc("DBL"),5);
	}
	}

	//stbar->changeItem(stloc("New File!"),1);
	//changed = FALSE;
}

void	ksoundsys::openClicked()
{
	char		name[1024];
	char		str[24];
	KFileDialog	*fd;
	QString		qstr;
	int		m;

	if(changed)
	{
		QString		str;
		int		result;

		str = "ksoundsys V" VERSION " \n\n";
		str += klocale->translate("The data has changed and is currently not saved!");
		KMsgBox	mb;
		result = mb.yesNoCancel(0,stloc("Load new soundfile?"),str,8,stloc("Abort"),stloc("Save now"),stloc("Load"));
		if(result == 1) return;
		if(result == 2) saveClicked();
	}

	fd = new KFileDialog();

	fd->exec();
	qstr = fd->getSelectedFile();
	strcpy(name,qstr.data());
	delete fd;

	m = kswp->getMode();
	kswp->setMode(SM_BUSY);
	disableMenu();
	if(kswp->loadWave(name) != 0)
	{
		stbar->changeItem(stloc("File not loaded!"),1);
		return;
	}
	kswp->setMode(m);
	enableMenu();

	{
		QString		group = "Option",str;

		config->setGroup(group);

		str = config->readEntry("DSP","/dev/dsp");

		kswp->getSample()->setAudioDevice(str);
	}

	stbar->changeItem(stloc("File loaded!"),1);
	qstr = stloc("Time: ");
	qstr += sprinttf(str,"%h:%2m:%2s.%3u",
		(int)((double)kswp->getSample()->getLength() / 
		       (double)kswp->getSample()->getRate() * 1000));
	stbar->changeItem(qstr,3);
	qstr = stloc("Samples: ");
	sprintf(str,"%12i",kswp->getSample()->getLength());
	qstr += str;
	stbar->changeItem(qstr,2);
	switch(kswp->getSample()->getNChannel())
	{
		case 1:
			stbar->changeItem(" Mono",4);
		break;
		case 2:
			stbar->changeItem("Stereo",4);
		break;
		case 4:
			stbar->changeItem("Quadro",4);
		break;
		default:
			sprintf(str,"%i",kswp->getSample()->getNChannel());
			stbar->changeItem(str,4);
	}
	if(kswp->getSample()->isType8()) stbar->changeItem(stloc("Int8"),5);
	if(kswp->getSample()->isType16()) stbar->changeItem(stloc("Int16"),5);
	if(kswp->getSample()->isType32()) stbar->changeItem(stloc("Int32"),5);
	if(kswp->getSample()->isTypeFL()) stbar->changeItem(stloc("FLT"),5);
	if(kswp->getSample()->isTypeDB()) stbar->changeItem(stloc("DBL"),5);

	changed = FALSE;
	if(projectname) free(projectname);
	projectname = strdup(name);
	kswp->setZoom(100);
	kswp->setDisplayStart(0);
	setRecent(name);

	kswp->setSample();
}

void	ksoundsys::openRecentClicked(int id)
{
	//int		i,t;
	QString		qstr = "";
	char		name[1024];
	char		str[24];
	int		m;

	config->setGroup("Recent Files");
	//i = config->readNumEntry("NFiles",8);

	qstr.sprintf("File%i",id - 1000);
	qstr = config->readEntry(qstr);

	// printf("ID = %i   File: %s   ",id,(char*)qstr.data());

	if(changed)
	{
		QString		str;
		int		result;

		str = "ksoundsys V" VERSION " \n\n";
		str += klocale->translate("The data has changed and is currently not saved!");
		KMsgBox	mb;
		result = mb.yesNoCancel(0,stloc("Load new soundfile?"),str,8,stloc("Abort"),stloc("Save now"),stloc("Load"));
		if(result == 1) return;
		if(result == 2) saveClicked();
	}

	strcpy(name,qstr.data());

	m = kswp->getMode();
	kswp->setMode(SM_BUSY);
	disableMenu();
	if(kswp->loadWave(name) != 0)
	{
		stbar->changeItem(stloc("File not loaded!"),1);
		return;
	}
	kswp->setMode(m);
	enableMenu();
	stbar->changeItem(stloc("File loaded!"),1);
	qstr = stloc("Time: ");
	qstr += sprinttf(str,"%h:%2m:%2s.%3u",
		(int)((double)kswp->getSample()->getLength() / 
		       (double)kswp->getSample()->getRate() * 1000));
	stbar->changeItem(qstr,3);
	qstr = stloc("Samples: ");
	sprintf(str,"%12i",kswp->getSample()->getLength());
	qstr += str;
	stbar->changeItem(qstr,2);
	switch(kswp->getSample()->getNChannel())
	{
		case 1:
			stbar->changeItem(" Mono",4);
		break;
		case 2:
			stbar->changeItem("Stereo",4);
		break;
		case 4:
			stbar->changeItem("Quadro",4);
		break;
		default:
			sprintf(str,"%i",kswp->getSample()->getNChannel());
			stbar->changeItem(str,4);
	}
	if(kswp->getSample()->isType8()) stbar->changeItem(stloc("Int8"),5);
	if(kswp->getSample()->isType16()) stbar->changeItem(stloc("Int16"),5);
	if(kswp->getSample()->isType32()) stbar->changeItem(stloc("Int32"),5);
	if(kswp->getSample()->isTypeFL()) stbar->changeItem(stloc("FLT"),5);
	if(kswp->getSample()->isTypeDB()) stbar->changeItem(stloc("DBL"),5);

	{
		QString		group = "Option",str;

		config->setGroup(group);

		str = config->readEntry("DSP","/dev/dsp");

		kswp->getSample()->setAudioDevice(str);
	}


	changed = FALSE;
	if(projectname) free(projectname);
	projectname = strdup(name);
	kswp->setZoom(100);
	kswp->setDisplayStart(0);
	setRecent(name);

	kswp->setSample();
}

void	ksoundsys::saveClicked()
{
	int		m;

	if(projectname == NULL)
	{
		saveAsClicked();
		return;
	}
	m = kswp->getMode();
	kswp->setMode(SM_BUSY);
	disableMenu();
	if(kswp->saveWave(projectname) != 0)
	{
		stbar->changeItem(stloc("File not saved!"),1);
		return;
	}
	kswp->setMode(m);
	enableMenu();
	stbar->changeItem(stloc("File saved!"),1);
	changed = FALSE;
}

void	ksoundsys::saveAsClicked()
{
	QString		qs;
	char		name[1024];
	KFileDialog	*fd;
	int		m;

	fd = new KFileDialog();

	fd->exec();
	qs = fd->getSelectedFile();
	strcpy(name,qs.data());
	delete fd;

	m = kswp->getMode();
	kswp->setMode(SM_BUSY);

	if(kswp->saveWave(name) != 0)
	{
		stbar->changeItem(stloc("File not saved!"),1);
		return;
	}

	kswp->setMode(m);
	stbar->changeItem(stloc("File saved!"),1);
	changed = FALSE;
	if(projectname) free(projectname);
	projectname = strdup(name);
}


void	ksoundsys::quitClicked()
{
	if(changed)
	{
		QString		str;
		int		result;

		str = "ksoundsys V" VERSION " \n\n";
		str += klocale->translate("The data has changed and is currently not saved!");
		KMsgBox	mb;
		result = mb.yesNoCancel(0,stloc("Exit program"),str,8,stloc("Abort"),stloc("Save now"),stloc("Exit"));
		if(result == 1) return;
		if(result == 2) saveClicked();
	}

	exit(0);
}

void	ksoundsys::helpClicked()
{
	QString		str,topic;

	str = "ksoundsys/";
	str += klocale->translate("index.html");
	kapp->invokeHTMLHelp(str,topic);
}

void	ksoundsys::aboutClicked()
{
	QString		str;

	str = "ksoundsys V" VERSION " \n\n";
	str += klocale->translate("Author:");
	str += " Tobias Wollgam\n\n\t\teMail: wollgam@cww.de\n\n";
	str += klocale->translate("Please report bugs to");
	str += ": wollgam@cww.de\n";
	KMsgBox	mb(0,stloc("About"),str,1,stloc("Quit"));
	mb.show();
}

void	ksoundsys::aboutQtClicked()
{
}

void	ksoundsys::copyClicked()
{
	uint		s,e,l,r;

	s = kswp->getSelectionStart();
	e = kswp->getSelectionEnd();
	l = e - s;

	cnpsample->equalize(kswp->getSample());
	//if(cnpsample->isType8()) printf("ksoundsys: copy: cnpsample now type I8\n");
	//if(cnpsample->isType16()) printf("ksoundsys: copy: cnpsample now type I16\n");
	//if(cnpsample->isTypeDB()) printf("ksoundsys: copy: cnpsample now type DB\n");

	r = kswp->getSample()->get(s,l,cnpsample);
	kswp->paint();
}

void	ksoundsys::cutClicked()
{
	uint		s,e,l;
	QString		qstr;
	char		str[24];

	s = kswp->getSelectionStart();
	e = kswp->getSelectionEnd();
	l = e - s;

	cnpsample->equalize(kswp->getSample());
	//if(cnpsample->isType8()) printf("ksoundsys: cut: cnpsample now type I8\n");
	//if(cnpsample->isType16()) printf("ksoundsys: cut: cnpsample now type I16\n");
	//if(cnpsample->isTypeDB()) printf("ksoundsys: cut: cnpsample now type DB\n");

	kswp->getSample()->cut(s,l,cnpsample);
	//kswp->setDisplayStart(kswp->getDisplayStart() - 1);
	kswp->setSelectionStart(-1);
	kswp->setSelectionEnd(-1);
	kswp->paint();

	qstr = stloc("Time: ");
	qstr += sprinttf(str,"%h:%2m:%2s.%3u",
		(int)((double)kswp->getSample()->getLength() / 
		       (double)kswp->getSample()->getRate() * 1000));
	stbar->changeItem(qstr,3);
	qstr = stloc("Samples: ");
	sprintf(str,"%12i",kswp->getSample()->getLength());
	qstr += str;
	stbar->changeItem(qstr,2);
}

void	ksoundsys::pasteClicked()
{
	uint		s;
	QString		qstr;
	char		str[24];

//	s = kswp->getSelectionStart();
	s = kswp->getPointer();

	kswp->getSample()->insert(s,cnpsample);
	printf("ksoundsys: paste: insert(%i,%i,cnpsample)\n",s,cnpsample->getLength());
	kswp->setSelectionStart(-1);
	kswp->setSelectionEnd(-1);
	kswp->paint();
	//kswp->setZoom(100);
	//kswp->setDisplayStart(0);

	qstr = stloc("Time: ");
	qstr += sprinttf(str,"%h:%2m:%2s.%3u",
		(int)((double)kswp->getSample()->getLength() / 
		       (double)kswp->getSample()->getRate() * 1000));
	stbar->changeItem(qstr,3);
	qstr = stloc("Samples: ");
	sprintf(str,"%12i",kswp->getSample()->getLength());
	qstr += str;
	stbar->changeItem(qstr,2);
}

void	ksoundsys::insertDND(char *url,int pos)
{
	uint		s;
	CSample		cs;
	QString		qstr;
	char		str[24];

	if(strncmp(url,"file",4) == 0)
	{
		cs.loadWave(url + 5);
		s = pos;
		if(!kswp->getSample()->insert(s,cs.getLength(),&cs))
		{
			int		result;
			if(changed)
			{
				QString		str;

				str = "ksoundsys V" VERSION " \n\n";
				str += klocale->translate("The data does not match. Load URL?");
				KMsgBox	mb;
				result = mb.yesNoCancel(0,stloc("Load new soundfile?"),str,8,stloc("Abort"),stloc("Insert to all channel"),stloc("Load"));
			}
			else result = 3;
			if(result == 1) return;
			else if(result == 2)
			{
				printf("Not implemented yet!\n");
				return;
			}
			else
			{
				if(kswp->getSample()->loadWave(url + 5) == 0)
					stbar->changeItem(stloc("URL loaded!"),1);
				else
					stbar->changeItem(stloc("Cannot load URL!"),1);
			}
		
		}
		else
		{
			stbar->changeItem(stloc("URL inserted!"),1);
		}
		qstr = stloc("Time: ");
		qstr += sprinttf(str,"%h:%2m:%2s.%3u",
			(int)((double)kswp->getSample()->getLength() / 
			       (double)kswp->getSample()->getRate() * 1000));
		stbar->changeItem(qstr,3);
		qstr = stloc("Samples: ");
		sprintf(str,"%12i",kswp->getSample()->getLength());
		qstr += str;
		stbar->changeItem(qstr,2);
		changed = TRUE;
		kswp->setZoom(100);
		//kswp->setDisplayStart(0);
	}
}

void	ksoundsys::editModeClicked()
{
	kswp->setMode(SM_SELECT);
}

void	ksoundsys::zoomModeClicked()
{
	kswp->setMode(SM_ZOOM);
}

void	ksoundsys::silenceClicked()
{
	QString		qstr;
	char		str[24];
	int		p,l;
	timedialog	td(this,"Insert Silence",config);
	double		sec;
	int		m;

	td.show();

	if(td.result())
	{
		sec = td.getSeconds();

		p = kswp->getPointer();
		l = (int)(sec * (double)kswp->getSample()->getRate());
		if(p < 0) p = 0;
		if(p > (int)kswp->getSample()->getLength())
		{
			p = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		CSample		ts(kswp->getSample()->getNChannel(),
				kswp->getSample()->getType(),l);
		//ts.equalize(kswp->getSample());
		//ts.resize(l);
		kswp->getSample()->insert(p,ts.getLength(),&ts);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Silence inserted"),1);

		qstr = stloc("Time: ");
		qstr += sprinttf(str,"%h:%2m:%2s.%3u",
			(int)((double)kswp->getSample()->getLength() / 
			       (double)kswp->getSample()->getRate() * 1000));
		stbar->changeItem(qstr,3);
		qstr = stloc("Samples: ");
		sprintf(str,"%12i",kswp->getSample()->getLength());
		qstr += str;
		stbar->changeItem(qstr,2);

		changed = TRUE;
		//kswp->setZoom(100);
		//kswp->setDisplayStart(0);
		kswp->paint();
	}
/*
	qstr = "ksoundsys V" VERSION " \n\n";
	qstr += klocale->translate("Insert silence not implemented yet!");
	KMsgBox	mb(0,stloc("Info"),qstr,1,stloc("Quit"));
	mb.show();
*/
}

void	ksoundsys::playClicked()
{
	int		s,e;

	s = kswp->getSelectionStart();
	e = kswp->getSelectionEnd();
	if(s < 0 || e < 0)
	{
		s = 0;
		e = kswp->getSample()->getLength();
	}

	kswp->getSample()->playback((uint)s,(uint)e);

	Maudio->setItemEnabled(mid[20],FALSE);
	Maudio->setItemEnabled(mid[21],TRUE);
	Maudio->setItemEnabled(mid[22],TRUE);
	Maudio->setItemEnabled(mid[23],FALSE);

	startTimer(250);
}

void	ksoundsys::stopClicked()
{
	killTimers();	
	kswp->getSample()->stop();

	Maudio->setItemEnabled(mid[20],TRUE);
	Maudio->setItemEnabled(mid[21],FALSE);
	Maudio->setItemEnabled(mid[22],FALSE);
	Maudio->setItemEnabled(mid[23],TRUE);
}

void	ksoundsys::pauseClicked()
{
	QString		str;

	str = "ksoundsys V" VERSION " \n\n";
	str += klocale->translate("Pause not implemented yet!");
	KMsgBox	mb(0,stloc("Info"),str,1,stloc("Quit"));
	mb.show();
}

void	ksoundsys::recordClicked()
{
	QString		str;

	str = "ksoundsys V" VERSION " \n\n";
	str += klocale->translate("Record not implemented yet!");
	KMsgBox	mb(0,stloc("Info"),str,1,stloc("Quit"));
	mb.show();
}

void	ksoundsys::optionsClicked()
{
	optiondialog	od(this,"Option",config);

	od.show();

	if(od.result())
	{
		QString		group = "Option",str;

		config->setGroup(group);

		str = config->readEntry("DSP","/dev/dsp");

		kswp->getSample()->setAudioDevice(str);
	}
}

void	ksoundsys::colorsClicked()
{
	QColor		*cp[11];
	QColor		c[11];
	int		t;

	kswp->getColors(c);

	for(t = 0;t < 11;t++)
	{
		cp[t] = new QColor(c[t]);
	}

	colordialog	cd(this,"Color",config,cp);

	cd.show();

	if(cd.result())
	{
		cd.getColors(cp);

		for(t = 0;t < 11;t++)
		{
			c[t] = *cp[t];
		}

		kswp->setColors(c);
		
		config->setGroup("SoundWidgetColors");
		config->writeEntry("Background",c[0]);
		config->writeEntry("Foreground",c[1]);
		config->writeEntry("NoColor",c[2]);
		config->writeEntry("Middleline",c[3]);
		config->writeEntry("Devideline",c[4]);
		config->writeEntry("SelectedBackground",c[5]);
		config->writeEntry("SelectedForeground",c[6]);
		config->writeEntry("SelectedMiddleline",c[7]);
		config->writeEntry("Pointer",c[8]);
		config->writeEntry("SelectedPointer",c[9]);
		config->writeEntry("Zoom",c[10]);
		config->sync();
	}

	for(t = 0;t < 11;t++)
	{
		delete cp[t];
	}
}

void	ksoundsys::formatClicked()
{
	int		sr = kswp->getSample()->getRate();
	//int		c = kswp->getSample()->getNChannel();
	int		t = 0;
	QString		qstr;
	char		str[24];
	int		m;

	if(kswp->getSample()->isType8()) t = 0;
	if(kswp->getSample()->isType16()) t = 1;
	if(kswp->getSample()->isType32()) t = 2;
	if(kswp->getSample()->isTypeFL()) t = 3;
	if(kswp->getSample()->isTypeDB()) t = 4;

	formatdialog fd(this,"Format",config,sr,t);

	fd.show();

	if(fd.result())
	{
		sr = fd.getSampleRate();
		t = fd.getType();

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		kswp->getSample()->convertToTypeDB();
		if(t == 0) kswp->getSample()->convertTypeDBToType8();
		if(t == 1) kswp->getSample()->convertTypeDBToType16();
		if(t == 2) kswp->getSample()->convertTypeDBToType32();
		if(t == 3) kswp->getSample()->convertTypeDBToTypeFL();

		kswp->getSample()->setRate(sr);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Format changed"),1);

		changed = TRUE;
		kswp->setSample();
		//kswp->paint();

		qstr = stloc("Time: ");
		qstr += sprinttf(str,"%h:%2m:%2s.%3u",
			(int)((double)kswp->getSample()->getLength() / 
			       (double)kswp->getSample()->getRate() * 1000));
		stbar->changeItem(qstr,3);
		qstr = stloc("Samples: ");
		sprintf(str,"%12i",kswp->getSample()->getLength());
		qstr += str;
		stbar->changeItem(qstr,2);
		switch(kswp->getSample()->getNChannel())
		{
			case 1:
				stbar->changeItem(" Mono",4);
			break;
			case 2:
				stbar->changeItem("Stereo",4);
			break;
			case 4:
				stbar->changeItem("Quadro",4);
			break;
			default:
				sprintf(str,"%i",kswp->getSample()->getNChannel());
				stbar->changeItem(str,4);
		}
		if(kswp->getSample()->isType8()) stbar->changeItem(stloc("Int8"),5);
		if(kswp->getSample()->isType16()) stbar->changeItem(stloc("Int16"),5);
		if(kswp->getSample()->isType32()) stbar->changeItem(stloc("Int32"),5);
		if(kswp->getSample()->isTypeFL()) stbar->changeItem(stloc("FLT"),5);
		if(kswp->getSample()->isTypeDB()) stbar->changeItem(stloc("DBL"),5);
	}
	kswp->setSample();
}

/*




		Hier kommen die Filterfunktionen
		--------------------------------



*/

#include "afx.h"
#include "kssdialogs.h"

void	ksoundsys::envelopeClicked()
{
	int		s,e,l;
	envdialog	envd(this,"Envelope",config);
	QArray<double>	points;
	int		m;

	envd.show();

	if(envd.result())
	{
		points = envd.getPoints();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.volume(kswp->getSample(),points,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Envelope-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::distortionClicked()
{
	int		s,e,l;
	distdialog	distd(this,"Distortion",config);
	QArray<double>	points;
	int		m,sym;

	distd.show();

	if(distd.result())
	{
		points = distd.getPoints();
		sym = distd.symmetric();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.distortion(kswp->getSample(),points,sym,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Distortion-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::deeppassClicked()
{
	int		s,e,l;
	dphpdialog	dphpd(this,"Deeppass",config);
	double		r,c;
	int		m;

	dphpd.show();

	if(dphpd.result())
	{
		r = dphpd.getR();
		c = dphpd.getC();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.deeppass(kswp->getSample(),c,r,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Deeppass-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::highpassClicked()
{
	int		s,e,l;
	dphpdialog	dphpd(this,"Highpass",config);
	double		r,c;
	int		m;

	dphpd.show();

	if(dphpd.result())
	{
		r = dphpd.getR();
		c = dphpd.getC();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.highpass(kswp->getSample(),c,r,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Highpass-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::echoClicked()
{
	int		s,e,l;
	echodialog	echod(this,"Echo",config);
	double		vol,delay,release;
	int		m;

	echod.show();

	if(echod.result())
	{
		delay = echod.getDelay();
		vol = echod.getVolume();
		release = echod.getRelease();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.echo(kswp->getSample(),delay,vol,release,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Echo-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::volumeClicked()
{
	int		s,e,l;
	voldialog	vold(this,"Volume",config);
	double		vol;
	int		m;

	vold.show();

	if(vold.result())
	{
		vol = vold.getVol();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.volume(kswp->getSample(),vol,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Volume-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::optimizeVolumeClicked()
{
	int		s,e,l;
	int		m;

	s = kswp->getSelectionStart();
	e = kswp->getSelectionEnd();
	l = e - s;
	if(s < 0 || e < 0)
	{
		s = 0;
		l = kswp->getSample()->getLength();
	}

	m = kswp->getMode();
	kswp->setMode(SM_BUSY);
	disableMenu();

	afx.volume(kswp->getSample(),s,l);

	kswp->setMode(m);
	enableMenu();

	stbar->changeItem(stloc("Optimized Volume"),1);

	changed = TRUE;
	kswp->paint();
}

void	ksoundsys::dcoffsetClicked()
{
	QString		str;
	int		m;

	str = "ksoundsys V" VERSION " \n\n";
	str += klocale->translate("DCOffset not implemented yet!");
	KMsgBox	mb(0,stloc("Info"),str,1,stloc("Quit"));
	mb.show();

	m = kswp->getMode();
	kswp->setMode(SM_BUSY);
	disableMenu();

	//afx.offsetDC(this);

	kswp->setMode(m);
	enableMenu();
}

void	ksoundsys::optimizeDCOffsetClicked()
{
	int		s,e,l;
	int		m;

	s = kswp->getSelectionStart();
	e = kswp->getSelectionEnd();
	l = e - s;
	if(s < 0 || e < 0)
	{
		s = 0;
		l = kswp->getSample()->getLength();
	}

	m = kswp->getMode();
	kswp->setMode(SM_BUSY);
	disableMenu();

	afx.optimizeDCOffset(kswp->getSample(),s,l);

	kswp->setMode(m);
	enableMenu();

	stbar->changeItem(stloc("Optimized DC-Offset"),1);

	changed = TRUE;
	kswp->paint();
}

void	ksoundsys::fuzzClicked()
{
	int		s,e,l;
	//int		side;
	fuzzdialog	fuzzd(this,"Fuzz",config);
	double		vol,cut;
	int		m;

	fuzzd.show();

	if(fuzzd.result())
	{
		vol = fuzzd.getVolume();
		cut = fuzzd.getCut();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.fuzz(kswp->getSample(),vol,cut,1,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Fuzz-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::noisegateClicked()
{
	int		s,e,l;
	noisegatedialog	ngd(this,"NoiseGate",config);
	double		treshhold;
	int		m;

	ngd.show();

	if(ngd.result())
	{
		treshhold = ngd.getTreshhold();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.noiseGate(kswp->getSample(),treshhold,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("NoiseGate-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::pitchShiftClicked()
{
	QString		str;
	int		m;

	str = "ksoundsys V" VERSION " \n\n";
	str += klocale->translate("PitchShift not implemented yet!");
	KMsgBox	mb(0,stloc("Info"),str,1,stloc("Quit"));
	mb.show();

	m = kswp->getMode();
	kswp->setMode(SM_BUSY);
	disableMenu();

	//afx.shiftpitch(this);

	kswp->setMode(m);
	enableMenu();
}

void	ksoundsys::hullcurveClicked()
{
	int		s,e,l,m;

	s = kswp->getSelectionStart();
	e = kswp->getSelectionEnd();
	l = e - s;
	if(s < 0 || e < 0)
	{
		s = 0;
		l = kswp->getSample()->getLength();
	}

	m = kswp->getMode();
	kswp->setMode(SM_BUSY);
	disableMenu();

	afx.hull(kswp->getSample(),s,l);

	kswp->setMode(m);
	enableMenu();

	stbar->changeItem(stloc("Hullcurve"),1);

	changed = TRUE;
	kswp->paint();
}

void	ksoundsys::compressClicked()
{
	int		s,e,l;
	compressdialog	cd(this,"Compress",config);
	double		level;
	int		m;

	cd.show();

	if(cd.result())
	{
		level = cd.getLevel();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.compress(kswp->getSample(),level,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Compress-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}

void	ksoundsys::expandClicked()
{
	int		s,e,l;
	compressdialog	cd(this,"Expand",config);
	double		level;
	int		m;

	cd.show();

	if(cd.result())
	{
		level = cd.getLevel();

		s = kswp->getSelectionStart();
		e = kswp->getSelectionEnd();
		l = e - s;
		if(s < 0 || e < 0)
		{
			s = 0;
			l = kswp->getSample()->getLength();
		}

		m = kswp->getMode();
		kswp->setMode(SM_BUSY);
		disableMenu();

		afx.expand(kswp->getSample(),level,s,l);

		kswp->setMode(m);
		enableMenu();

		stbar->changeItem(stloc("Expand-filtered"),1);

		changed = TRUE;
		kswp->paint();
	}
}





