#ifndef __KSOUNDSYS__
#define __KSOUNDSYS__



#include <kapp.h>
#include <kpopmenu.h>
#include <kmenubar.h>
#include <ktopwidget.h>
#include <kstatusbar.h>
#include <qlabel.h>
#include <qlined.h>
#include <qchkbox.h>
#include <qstrlist.h>
#include "KFileDialog.h"

#include "ksoundwidgetpro.h"
#include "kssdialogs.h"

#ifdef VERSION
#undef VERSION
#endif

#ifdef PACKAGE
#undef PACKAGE
#endif

#include "../config.h"

#include "afx.h"


#define MPopupMenu	QPopupMenu

class ksoundsys : public KTopLevelWidget
{
	Q_OBJECT
public:
	ksoundsys(KApplication *);
	~ksoundsys();

public slots:
	// Menu File
	void	newClicked();
	void	openClicked();
	void	openRecentClicked(int);
	void	saveClicked();
	void	saveAsClicked();
	void	quitClicked();

	// Menu Edit
	void	copyClicked();
	void	cutClicked();
	void	pasteClicked();
	void	silenceClicked();
	void	formatClicked();

	// Menu Audio
	void	playClicked();
	void	stopClicked();
	void	pauseClicked();
	void	recordClicked();

	// Menu Filter
	void	deeppassClicked();
	void	highpassClicked();
	void	echoClicked();
	void	volumeClicked();
	void	optimizeVolumeClicked();
	void	dcoffsetClicked();
	void	optimizeDCOffsetClicked();
	void	fuzzClicked();
	void	pitchShiftClicked();
	void	noisegateClicked();
	void	distortionClicked();
	void	envelopeClicked();
	void	hullcurveClicked();
	void	compressClicked();
	void	expandClicked();

	// Menu Options
	void	optionsClicked();
	void	colorsClicked();

	// Menu Help
	void	helpClicked();
	void	aboutQtClicked();
	void	aboutClicked();

	// DND Insert
	void	insertDND(char *,int);

	// Toolbar Modes
	void	editModeClicked();
	void	zoomModeClicked();

private:
	void	disableMenu();
	void	enableMenu();
	void	createToolBars();

	void	timerEvent(QTimerEvent*);

private:
	char		*projectname;
	int		changed;

	KStatusBar	*stbar;
	MPopupMenu	*Mfile,*Medit,*Maudio,*Mfilter,*Moptions,*Mhelp,*Mopenrecent;
	KMenuBar	*mainmenu;
	KToolBar	*tb_file;
	KToolBar	*tb_edit;
	KToolBar	*tb_filter;
	KToolBar	*tb_audio;

	KSoundWidgetPro	*kswp;

	int		mid[60];

	CSample		*undosample,*cnpsample;

	CAFX		afx;

	KConfig		*config;
	KApplication	*app;


private:
	void	createWidgets();
	void	createMenu();
	void	setRecent(char *);
	void	progress(double,char*);
};

#endif

