#ifndef __KSOUNDWIDGETPRO__
#define __KSOUNDWIDGETPRO__


#include <kapp.h>  

#include <qwidget.h>
#include <qscrbar.h>
#include <kbutton.h>
#include <qbutton.h>
#include <qpushbt.h>
#include "ksoundwidget.h"
#include "kscalebar.h"
#include "ktimebar.h"

class KSoundWidgetPro : public QWidget
{
	Q_OBJECT
protected:

	KSoundWidget		*ksw;
	QScrollBar		*qsb;
	QPushButton		*zoom_in,*zoom_out;
	QButton			*mode_select,*mode_zoom;
	QPixmap			pm_zoom_in,pm_zoom_out;
	KTimeBar		*ktb;
	QArray<KScaleBar*>	ksb;
	int			nchannel;
	KApplication		*app;

protected:

	void		createWidgets(CSample *s = NULL);
	void		layout();
	void		paintEvent(QPaintEvent *);
	//void		resizeEvent(QResizeEvent *);


public:

	KSoundWidgetPro(QWidget *parent,KApplication*);
	KSoundWidgetPro(QWidget *parent,CSample *s,KApplication*);
	~KSoundWidgetPro();

	//CSample		*getSample();

	void		paint();
	void		setMode(int m);
	int		getMode() { return ksw->getMode();};
	void		setSample(CSample *s);
	void		setSample();
	int		loadWave(char* fn)
			{
				int		result;
				CSample		*s = new CSample();

				if((result = s->loadWave(fn)) == 0)
				{
					setSample(s);
				}

				delete s;

				return result;
			};
	int		saveWave(char* fn)
			{
				return ksw->saveWave(fn);
			};
	CSample		*getSample()
			{
				return ksw;
			};
	int		setZoom(int zoom)
	{
		ksw->setDisplayZoom(zoom);
		return ksw->getDisplayZoom();
	}
	int		getZoom(void)
	{
		return ksw->getDisplayZoom();
	}
	int		setDisplayStart(int ds)
	{
		ksw->setDisplayStart(ds);
		return ksw->getDisplayStart();
	}
	int		getDisplayStart(void)
	{
		return ksw->getDisplayStart();
	}
	unsigned int	getSelectionStart()
	{
		return ksw->getSelectionStart();
	}
	unsigned int	getSelectionEnd()
	{
		return ksw->getSelectionEnd();
	}
	void		setSelectionStart(int ss)
	{
		ksw->setSelectionStart(ss);
	}
	void		setSelectionEnd(int se)
	{
		ksw->setSelectionEnd(se);
	}
	int		getPointer()
	{
		return ksw->getPointer();
	}
	void		getColors(QColor *color);
	void		setColors(QColor *color);

public slots:

	void		changedScroll(int v);
	void		changedDispStart(int v);
	void		changedDispZoom(int v);
	void		clickedZoomIn();
	void		clickedZoomOut();

	void		gotDndURL(char *,int);

signals:
	void		gotURL(char*,int);
};

#endif


