#ifndef __KTIMEBAR__
#define __KTIMEBAR__

#include <qpainter.h>
#include <qframe.h>

#ifndef MIN
#define MIN(a,b)	((a) < (b)?(a):(b))
#endif

#ifndef MAX
#define MAX(a,b)	((a) > (b)?(a):(b))
#endif

class KTimeBar : public QFrame
{
	Q_OBJECT
protected:

	uint		nmarks,minstep;
	int		min_value,max_value,start_value,end_value;
	QString		format;

	QPainter	*qp;

protected:

	void	draw();


	//void	resizeEvent(QResizeEvent*);
	void	paintEvent(QPaintEvent*);

public:

	KTimeBar(QWidget *parent);
	~KTimeBar();

	void	setMinStep(uint n)
	{
		minstep = n;
		draw();
	};	
	void	setStart(uint n)
	{
		start_value = n;
		draw();
	};	
	void	setEnd(uint n)
	{
		end_value = n;
		draw();
	};	
	void	setRange(int s,int e)
	{
		end_value = e;
		start_value = s;
		draw();
	};
	void	setTimeRange(int min,int max)
	{
		min_value = min;
		max_value = max;
		draw();
	};
	void	setFormatString(QString f)
	{
		format = f;
		draw();
	};

	void	sprinttf(QString*,QString,int i);
};

	
#endif


